## xenomai 2.6.4+dfsg

=== ksrc/Makefile ===
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

# Makefile frag for Linux v2.6 and v3.x

obj-$(CONFIG_XENOMAI) += arch/ nucleus/ skins/

else

# Makefile frag for Linux v2.4

subdir-$(CONFIG_XENOMAI) += arch

subdir-$(CONFIG_XENO_OPT_NUCLEUS) += nucleus

mod-subdirs := skins
subdir-y += skins

include $(TOPDIR)/Rules.make

endif

=== examples/posix/Makefile ===
###### CONFIGURATION ######

### List of applications to be build
APPLICATIONS = satch

### Note: to override the search path for the xeno-config script, use "make XENO=..."

### List of modules to be build
MODULES = satch

### Note: to override the kernel source path, use "make KSRC=..."

all::

satch: satch.c

###### USER SPACE BUILD (no change required normally) ######
ifeq ($(KERNELRELEASE),)
ifneq ($(APPLICATIONS),)

### Default Xenomai installation path
XENO ?= /usr/xenomai

XENOCONFIG=$(shell PATH=$(XENO):$(XENO)/bin:$(PATH) which xeno-config 2>/dev/null)

### Sanity check
ifeq ($(XENOCONFIG),)
all::
	@echo ">>> Invoke make like this: \"make XENO=/path/to/xeno-config\" <<<"
	@echo
endif


CC=$(shell $(XENOCONFIG) --cc)

CFLAGS=-DCONSUMER $(shell $(XENOCONFIG) --skin=posix --cflags) $(MY_CFLAGS)

LDFLAGS=$(MY_LDFLAGS)
LDLIBS=$(shell $(XENOCONFIG) --skin=posix --ldflags)

# This includes the library path of given Xenomai into the binary to make live
# easier for beginners if Xenomai's libs are not in any default search path.
LDFLAGS+=-Xlinker -rpath -Xlinker $(shell $(XENOCONFIG) --libdir)

all:: $(APPLICATIONS)

clean::
	$(RM) $(APPLICATIONS) *.o

endif
endif



###### KERNEL MODULE BUILD (no change required normally) ######
ifneq ($(MODULES),)
### Default to sources of currently running kernel
KSRC ?= /lib/modules/$(shell uname -r)/build

OBJS     := ${patsubst %, %.o, $(MODULES)}
CLEANMOD := ${patsubst %, .%*, $(MODULES)}
PWD      := $(shell if [ "$$PWD" != "" ]; then echo $$PWD; else pwd; fi)

### Kernel 2.6 or 3.0
PATCHLEVEL:=$(shell sed 's/PATCHLEVEL = \(.*\)/\1/;t;d' $(KSRC)/Makefile)
VERSION:=$(shell sed 's/VERSION = \(.*\)/\1/;t;d' $(KSRC)/Makefile)
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

obj-m        := $(OBJS)
EXTRA_CFLAGS := -DPRODUCER -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/posix $(ADD_CFLAGS)

all::
	echo $(MAKE) -C $(KSRC) ARCH=$(ARCH) CROSS_COMPILE=$(CROSS_COMPILE) SUBDIRS=$(PWD) modules
	$(MAKE) -C $(KSRC) ARCH=$(ARCH) CROSS_COMPILE=$(CROSS_COMPILE) SUBDIRS=$(PWD) modules
	$(RM) *.o

### Kernel 2.4
else

ARCH    ?= $(shell uname -i)
INCLUDE := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/compat -I$(KSRC)/include/xenomai/posix
CFLAGS  += $(shell $(MAKE) -s -C $(KSRC) CC=$(CC) ARCH=$(ARCH) SUBDIRS=$(PWD) modules) $(INCLUDE)

all:: $(OBJS)
	/bin/false

endif

## Target for capturing 2.4 module CFLAGS
modules:
	@echo "$(CFLAGS)"

clean::
	$(RM) $(CLEANMOD) *.o *.ko *.mod.c Module*.symvers Module.markers modules.order
	$(RM) -R .tmp*

endif

=== ksrc/arch/Makefile ===
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

# Makefile frag for Linux v2.6 and v3.x

obj-$(CONFIG_XENOMAI) += generic/

else

# Makefile frag for Linux v2.4

subdir-y += generic

include $(TOPDIR)/Rules.make

endif

=== ksrc/drivers/Makefile ===
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

# Makefile frag for Linux v2.6 and v3.x

obj-$(CONFIG_XENOMAI) += serial/ testing/ can/ analogy/ ipc/

else

# Makefile frag for Linux v2.4

mod-subdirs := serial testing can analogy ipc

subdir-$(CONFIG_XENO_DRIVERS_16550A) += serial

subdir-$(CONFIG_XENO_DRIVERS_TIMERBENCH) += testing
subdir-$(CONFIG_XENO_DRIVERS_IRQBENCH)   += testing
subdir-$(CONFIG_XENO_DRIVERS_SWITCHTEST) += testing

subdir-$(CONFIG_XENO_DRIVERS_CAN) += can
subdir-$(CONFIG_XENO_DRIVERS_ANALOGY) += analogy
subdir-$(CONFIG_XENO_DRIVERS_MPIPE) += ipc

include $(TOPDIR)/Rules.make

endif

=== ksrc/arch/nios2/Makefile ===

obj-$(CONFIG_XENOMAI) += xeno_hal.o

xeno_hal-y := hal.o switch.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

=== ksrc/arch/x86/Makefile ===
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

# Makefile frag for Linux v2.6 and v3.x

ifeq ($(CONFIG_X86_64),y)
X86_MODE := 64
else
X86_MODE := 32
endif

obj-$(CONFIG_XENOMAI) += xeno_hal.o

xeno_hal-y := hal_$(X86_MODE).o hal-common.o usercopy_$(X86_MODE).o smi.o c1e.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

else

# Makefile frag for Linux v2.4

USE_STANDARD_AS_RULE := true

O_TARGET := built-in.o

obj-y := hal_32.o hal-common.o smi.o

export-objs := $(obj-y) $(obj-m)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat

include $(TOPDIR)/Rules.make

endif

=== ksrc/drivers/analogy/Makefile ===
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

# Makefile frag for Linux v2.6 and v3.x

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai -Idrivers/xenomai/analogy

obj-$(CONFIG_XENO_DRIVERS_ANALOGY) += xeno_analogy.o testing/ intel/ national_instruments/ sensoray/

xeno_analogy-y := \
	buffer.o \
	command.o \
	device.o \
	driver.o \
	driver_facilities.o \
	instruction.o \
	os_facilities.o \
	subdevice.o \
	transfer.o

xeno_analogy-$(CONFIG_XENO_OPT_PERVASIVE) += rtdm_interface.o

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

subdir-$(CONFIG_XENO_DRIVERS_ANALOGY_FAKE) += testing
subdir-$(CONFIG_XENO_DRIVERS_ANALOGY_LOOP) += testing
subdir-$(CONFIG_XENO_DRIVERS_ANALOGY_8255) += intel
subdir-$(CONFIG_XENO_DRIVERS_ANALOGY_NI_MITE) += national_instruments
subdir-$(CONFIG_XENO_DRIVERS_ANALOGY_S526) += sensoray

obj-$(CONFIG_XENO_DRIVERS_ANALOGY) += xeno_analogy.o

opt_objs-y :=
opt_objs-$(CONFIG_XENO_OPT_PERVASIVE) += rtdm_interface.o

xeno_analogy-objs := \
	buffer.o \
	command.o \
	device.o \
	driver.o \
	driver_facilities.o \
	instruction.o \
	os_facilities.o \
	subdevice.o \
	transfer.o

xeno_analogy-objs += $(opt_objs-y)

export-objs := $(xeno_analogy-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat -I.

include $(TOPDIR)/Rules.make

xeno_analogy.o: $(xeno_analogy-objs)
	$(LD) -r -o $@ $(xeno_analogy-objs)

endif

=== ksrc/drivers/can/Makefile ===
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

# Makefile frag for Linux v2.6 and v3.x

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai -Idrivers/xenomai/can

obj-$(CONFIG_XENO_DRIVERS_CAN) += xeno_can.o mscan/ sja1000/
obj-$(CONFIG_XENO_DRIVERS_CAN_FLEXCAN) += xeno_can_flexcan.o
obj-$(CONFIG_XENO_DRIVERS_CAN_VIRT) += xeno_can_virt.o

xeno_can-y := rtcan_dev.o rtcan_socket.o rtcan_module.o rtcan_raw.o rtcan_raw_dev.o rtcan_raw_filter.o
xeno_can_virt-y := rtcan_virt.o
xeno_can_flexcan-y := rtcan_flexcan.o

else

# Makefile frag for Linux v2.4

mod-subdirs := mscan sja1000

subdir-$(CONFIG_XENO_DRIVERS_CAN_MSCAN) += mscan
subdir-$(CONFIG_XENO_DRIVERS_CAN_SJA1000) += sja1000

O_TARGET := built-in.o

obj-$(CONFIG_XENO_DRIVERS_CAN) += xeno_can.o
obj-$(CONFIG_XENO_DRIVERS_CAN_VIRT) += xeno_can_virt.o

list-multi := xeno_can.o

xeno_can-objs := rtcan_dev.o rtcan_socket.o rtcan_module.o rtcan_raw.o rtcan_raw_dev.o rtcan_raw_filter.o
xeno_can_virt-objs := rtcan_virt.o

export-objs := $(xeno_can-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat -I.

include $(TOPDIR)/Rules.make

xeno_can.o: $(xeno_can-objs)
	$(LD) -r -o $@ $(xeno_can-objs)

xeno_can_virt.o: $(xeno_can_virt-objs)
	$(LD) -r -o $@ $(xeno_can_virt-objs)

endif

=== ksrc/drivers/ipc/Makefile ===
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

# Makefile frag for Linux v2.6 and v3.x

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai -Idrivers/xenomai/ipc

obj-$(CONFIG_XENO_DRIVERS_RTIPC) += xeno_rtipc.o

xeno_rtipc-y := rtipc.o

xeno_rtipc-$(CONFIG_XENO_DRIVERS_RTIPC_XDDP) += xddp.o
xeno_rtipc-$(CONFIG_XENO_DRIVERS_RTIPC_IDDP) += iddp.o
xeno_rtipc-$(CONFIG_XENO_DRIVERS_RTIPC_BUFP) += bufp.o

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

obj-$(CONFIG_XENO_DRIVERS_RTIPC) += xeno_rtipc.o

xeno_rtipc-objs := rtipc.o

opt_objs-y :=
opt_objs-$(CONFIG_XENO_DRIVERS_RTIPC_XDDP) += xddp.o
opt_objs-$(CONFIG_XENO_DRIVERS_RTIPC_IDDP) += iddp.o
opt_objs-$(CONFIG_XENO_DRIVERS_RTIPC_BUFP) += bufp.o

xeno_rtipc-objs += $(opt_objs-y)

export-objs := $(xeno_rtipc-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat -I.

include $(TOPDIR)/Rules.make

xeno_rtipc.o: $(xeno_rtipc-objs)
	$(LD) -r -o $@ $(xeno_rtipc-objs)

endif

=== ksrc/drivers/testing/Makefile ===
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

# Makefile frag for Linux v2.6 and v3.x

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

obj-$(CONFIG_XENO_DRIVERS_TIMERBENCH) += xeno_timerbench.o
obj-$(CONFIG_XENO_DRIVERS_IRQBENCH)   += xeno_irqbench.o
obj-$(CONFIG_XENO_DRIVERS_SWITCHTEST) += xeno_switchtest.o
obj-$(CONFIG_XENO_DRIVERS_KLATENCY)   += xeno_klat.o
obj-$(CONFIG_XENO_DRIVERS_RTDMTEST)   += xeno_rtdmtest.o

xeno_timerbench-y := timerbench.o

xeno_irqbench-y := irqbench.o

xeno_switchtest-y := switchtest.o

xeno_klat-y := klat.o

xeno_rtdmtest-y := rtdmtest.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

obj-$(CONFIG_XENO_DRIVERS_TIMERBENCH) += xeno_timerbench.o
obj-$(CONFIG_XENO_DRIVERS_IRQBENCH)   += xeno_irqbench.o
obj-$(CONFIG_XENO_DRIVERS_SWITCHTEST) += xeno_switchtest.o
obj-$(CONFIG_XENO_DRIVERS_KLATENCY)   += xeno_klat.o
obj-$(CONFIG_XENO_DRIVERS_RTDMTEST)   += xeno_rtdmtest.o

xeno_timerbench-objs := timerbench.o

xeno_irqbench-objs := irqbench.o

xeno_switchtest-objs := switchtest.o

xeno_klat-objs := klat.o

xeno_rtdmtest-objs := rtdmtest.o

export-objs := $(xeno_timerbench-objs) $(xeno_irqbench-objs) \
	$(xeno_switchtest-objs) $(xeno_klat-objs) \
	$(xeno_rtdmtest-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat

include $(TOPDIR)/Rules.make

xeno_timerbench.o: $(xeno_timerbench-objs)
	$(LD) -r -o $@ $(xeno_timerbench-objs)

xeno_irqbench.o: $(xeno_irqbench-objs)
	$(LD) -r -o $@ $(xeno_irqbench-objs)

xeno_switchtest.o: $(xeno_switchtest-objs)
	$(LD) -r -o $@ $(xeno_switchtest-objs)

xeno_klat.o: $(xeno_klat-objs)
	$(LD) -r -o $@ $(xeno_klat-objs)

xeno_rtdmtest.o: $(xeno_rtdmtest-objs)
	$(LD) -r -o $@ $(xeno_rtdmtest-objs)

endif

=== ksrc/skins/native/Makefile ===
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

# Makefile frag for Linux v2.6 and v3.x

obj-$(CONFIG_XENO_SKIN_NATIVE) += xeno_native.o

xeno_native-y := module.o task.o timer.o

xeno_native-$(CONFIG_XENO_OPT_PERVASIVE) += syscall.o

xeno_native-$(CONFIG_XENO_OPT_NATIVE_PIPE) += pipe.o

xeno_native-$(CONFIG_XENO_OPT_NATIVE_SEM) += sem.o

xeno_native-$(CONFIG_XENO_OPT_NATIVE_EVENT) += event.o

xeno_native-$(CONFIG_XENO_OPT_NATIVE_MUTEX) += mutex.o

xeno_native-$(CONFIG_XENO_OPT_NATIVE_COND) += cond.o

xeno_native-$(CONFIG_XENO_OPT_NATIVE_QUEUE) += queue.o

xeno_native-$(CONFIG_XENO_OPT_NATIVE_HEAP) += heap.o

xeno_native-$(CONFIG_XENO_OPT_NATIVE_ALARM) += alarm.o

xeno_native-$(CONFIG_XENO_OPT_NATIVE_INTR) += intr.o

xeno_native-$(CONFIG_XENO_OPT_NATIVE_BUFFER) += buffer.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

obj-$(CONFIG_XENO_SKIN_NATIVE) := xeno_native.o

xeno_native-objs := module.o task.o timer.o

opt_objs-y :=
opt_objs-$(CONFIG_XENO_OPT_PERVASIVE) += syscall.o
opt_objs-$(CONFIG_XENO_OPT_NATIVE_PIPE) += pipe.o
opt_objs-$(CONFIG_XENO_OPT_NATIVE_SEM) += sem.o
opt_objs-$(CONFIG_XENO_OPT_NATIVE_EVENT) += event.o
opt_objs-$(CONFIG_XENO_OPT_NATIVE_MUTEX) += mutex.o
opt_objs-$(CONFIG_XENO_OPT_NATIVE_COND) += cond.o
opt_objs-$(CONFIG_XENO_OPT_NATIVE_QUEUE) += queue.o
opt_objs-$(CONFIG_XENO_OPT_NATIVE_HEAP) += heap.o
opt_objs-$(CONFIG_XENO_OPT_NATIVE_ALARM) += alarm.o
opt_objs-$(CONFIG_XENO_OPT_NATIVE_INTR) += intr.o
opt_objs-$(CONFIG_XENO_OPT_NATIVE_BUFFER) += buffer.o

xeno_native-objs += $(opt_objs-y)

export-objs := $(xeno_native-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat

include $(TOPDIR)/Rules.make

xeno_native.o: $(xeno_native-objs)
	$(LD) -r -o $@ $(xeno_native-objs)

endif

=== ksrc/skins/psos+/Makefile ===
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

# Makefile frag for Linux v2.6 and v3.x

obj-$(CONFIG_XENO_SKIN_PSOS) += xeno_psos.o

xeno_psos-y := module.o asr.o event.o pt.o queue.o rn.o task.o tm.o sem.o

xeno_psos-$(CONFIG_XENO_OPT_PERVASIVE) += syscall.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

obj-$(CONFIG_XENO_SKIN_PSOS) := xeno_psos.o

list-multi := xeno_psos.o

opt_objs-y :=
opt_objs-$(CONFIG_XENO_OPT_PERVASIVE) += syscall.o

xeno_psos-objs := module.o asr.o event.o pt.o queue.o rn.o task.o tm.o sem.o $(opt_objs-y)

export-objs := $(xeno_psos-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat

include $(TOPDIR)/Rules.make

xeno_psos.o: $(xeno_psos-objs)
	$(LD) -r -o $@ $(xeno_psos-objs)

endif

=== debian/changelog ===
xenomai (2.6.4+dfsg-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Added Conflicts to libxenomai1 (<< 2.6.4). Closes: #806145

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Wed, 23 Dec 2015 09:02:16 +0100

xenomai (2.6.4+dfsg-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream version without debian 
    directory (+dfsg). (Closes:  #791980)
  * Could be built. No gzip problem. (Closes: #802420)
  * Added Leopold Palomo-Avellaneda as Uploaders.
  * Bump Standards to 3.9.6.
  * Change to dh-autoreconf
  * Renamed xenomai-runtime by xenomai-system-tools
  * Added libjs-jquery to xenomai-doc depends
  * Enable fortify and change install libdir to multiarch
  * Updated copyright file
  * Deleting installed extra-license-file
  * Added jquery.js source
  * Added documentation under doc-base
  * Dropping udev part. Manage by dh_installudev
  * Renaming linux-patch-xenomai by xenomai-kernel-source
  * Added init file
  * Added modprobe config
  * Correct lintian-overrides files
  * Dropped /dev from the lib package. It's managed by udev in another package
  * Added dependencies to xenomai-kernel-source
  * Tunning suggestions and conflicts of the packages
  * Delete old no used patches
  * Update README
  * Added patch to build with kernels >= 3.11

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Tue, 09 Jun 2015 10:26:26 +0200

=== debian/control ===
Source: xenomai
Section: devel
Priority: extra
Maintainer: Roland Stigge <stigge@antcom.de>
Build-Depends: debhelper (>= 9), findutils (>= 4.2.28), 
		dh-autoreconf, 
		libtool, dh-exec (>=0.3)
Standards-Version: 3.9.6
Homepage: http://www.xenomai.org/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/xenomai.git
Vcs-Git: git://anonscm.debian.org/collab-maint/xenomai.git

Package: xenomai-system-tools
Section: admin
Architecture: amd64 arm armeb armel i386 powerpc powerpcspe
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: xenomai-kernel-source, xenomai-doc
Replaces: xenomai-runtime
Conflicts: xenomai-runtime, libxenomai1 (<< 2.6.4)
Description: Xenomai system tools utilities
 Xenomai is a real-time development framework cooperating with the Linux
 kernel in order to provide a pervasive, interface-agnostic, hard real-time
 support to user-space applications, seamlessly integrated into the GNU/Linux
 environment. Xenomai provides its own API and emulation layers ("skins") to
 make migration from other RTOS easier. Examples are: pSOS+, VxWorks, VRTX,
 uiTRON, RTAI, POSIX.
 .
 This package contains the runtime programs, testsuite for the Xenomai
 realtime system and system configuration scripts.

Package: xenomai-kernel-source
Section: kernel
Architecture: all
Depends: ${misc:Depends}, kernel-package, libncurses-dev, fakeroot,
	zlib1g-dev, libxenomai-dev
Replaces: linux-patch-xenomai
Suggests: xenomai, linux-source
Description: Linux kernel patches for Xenomai
 Xenomai is a real-time development framework cooperating with the Linux
 kernel in order to provide a pervasive, interface-agnostic, hard real-time
 support to user-space applications, seamlessly integrated into the GNU/Linux
 environment. Xenomai provides its own API and emulation layers ("skins") to
 make migration from other RTOS easier. Examples are: pSOS+, VxWorks, VRTX,
 uiTRON, RTAI, POSIX.
 .
 This package contains patches for 2.6 series kernels - These are intended for
 use with kernel-package and a virgin Linux source tree. Note: These patches
 include the base adeos-ipipe patch along with all the additional material
 normally added by the prepare-kernel.sh script.
 .
 This package contains the following patches:
 .

Package: libxenomai1
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Architecture: amd64 arm armeb armel i386 powerpc powerpcspe
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: xenomai-system-tools, xenomai-doc
Replaces: xenomai
Conflicts: xenomai
Description: Shared libraries for Xenomai
 Xenomai is a real-time development framework cooperating with the Linux
 kernel in order to provide a pervasive, interface-agnostic, hard real-time
 support to user-space applications, seamlessly integrated into the GNU/Linux
 environment. Xenomai provides its own API and emulation layers ("skins") to
 make migration from other RTOS easier. Examples are: pSOS+, VxWorks, VRTX,
 uiTRON, RTAI, POSIX.
 .
 This package contains the shared libraries.

Package: libxenomai-dev
Section: libdevel
Architecture: amd64 arm armeb armel i386 powerpc powerpcspe
Depends: libxenomai1 (= ${binary:Version}), ${misc:Depends}
Suggests: linux-patch-xenomai, xenomai-doc
Replaces: xenomai
Conflicts: xenomai
Description: Headers and static libs for Xenomai
 Xenomai is a real-time development framework cooperating with the Linux
 kernel in order to provide a pervasive, interface-agnostic, hard real-time
 support to user-space applications, seamlessly integrated into the GNU/Linux
 environment. Xenomai provides its own API and emulation layers ("skins") to
 make migration from other RTOS easier. Examples are: pSOS+, VxWorks, VRTX,
 uiTRON, RTAI, POSIX.
 .
 This package contains development files (header files), the static libraries
 and scripts used to compile realtime applications.

Package: xenomai-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, libjs-jquery
Suggests: xenomai
Conflicts: xenomai-docs
Replaces: xenomai-docs
Description: Xenomai documentation
 Xenomai is a real-time development framework cooperating with the Linux
 kernel in order to provide a pervasive, interface-agnostic, hard real-time
 support to user-space applications, seamlessly integrated into the GNU/Linux
 environment. Xenomai provides its own API and emulation layers ("skins") to
 make migration from other RTOS easier. Examples are: pSOS+, VxWorks, VRTX,
 uiTRON, RTAI, POSIX.
 .
 Documentation for Xenomai realtime API.

=== debian/rules ===
#!/usr/bin/make -f

##################
### To be clarified
# Author: Paul Corner <paul_c@gna.org>
# Leo and Roland, Gilles
# Created on: Sat Mar 3 12:00 GMT 2007
# License: GPL Ver. 2
##################

# Hardening.
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
export DEB_BUILD_HARDENING=1
#DEB_BUILD_OPTIONS += nocheck

#export DH_VERBOSE=1

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
# necessary from GCC 4.6 on (no-omit-frame-pointer)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS) -fno-omit-frame-pointer
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)

DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_GNU_TYPE=$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE=$(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

# Multiarch.
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)



ifeq ($(DEB_HOST_ARCH), i386)
# Note: Would like to use --includedir=/usr/include/xenomai, but
# there appears to be a `make install` problem.
	CONFIG_OPTS = \
	            --enable-x86-tsc
endif
ifeq ($(DEB_HOST_ARCH), amd64)
	CONFIG_OPTS = \
	            --enable-x86-tsc \
	            --enable-x86-sep
endif
ifeq ($(DEB_HOST_ARCH), powerpc)
	CONFIG_OPTS =
endif
CONFIG_OPTS += --prefix=/usr \
	            --includedir=/usr/include/xenomai \
	            --mandir=/usr/share/man \
		    --with-testdir=/usr/lib/$(DEB_HOST_MULTIARCH)/xenomai \
		    --enable-fortify \
		    --libdir='$${prefix}/lib/$(DEB_HOST_MULTIARCH)/'\
		    --enable-shared

ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
	CONFIG_OPTS += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
else
	CONFIG_OPTS += --build $(DEB_BUILD_GNU_TYPE)
endif


#################################################
%:
	dh $@ --parallel --with autoreconf

#### Configure ####
override_dh_auto_configure:
#	autoreconf -fi
	dh_auto_configure -- $(CONFIG_OPTS)

override_dh_auto_install:
	# Creating the debian file
	cat ksrc/nucleus/udev/rtheap.rules >  debian/xenomai-system-tools.xenomai.udev
	cat ksrc/nucleus/udev/rtpipe.rules >> debian/xenomai-system-tools.xenomai.udev

# Copying some interesting files to use in the package
	mkdir -p debian/tmp/usr/src/xenomai-kernel-source 
	mkdir -p debian/tmp/usr/share/libxenomai-dev/examples/kernel/skins
	cp -a ksrc include scripts debian/tmp/usr/src/xenomai-kernel-source/
	cp -r examples debian/tmp/usr/share/libxenomai-dev 
	cp -r ksrc/skins/native/demos debian/tmp/usr/share/libxenomai-dev/examples/kernel/skins/native
	cp -r ksrc/skins/native/snippets debian/tmp/usr/share/libxenomai-dev/examples/kernel/skins/native
	cp -r ksrc/skins/posix/demos debian/tmp/usr/share/libxenomai-dev/examples/kernel/skins/posix
	cp -r ksrc/skins/psos+/demos debian/tmp/usr/share/libxenomai-dev/examples/kernel/skins/psos+
	cp -r ksrc/skins/vxworks/demos debian/tmp/usr/share/libxenomai-dev/examples/kernel/skins/vxworks

	# Deleting extra-license-file
	rm -rf debian/tmp/usr/src/xenomai-kernel-source/include/COPYING \
		debian/tmp/usr/src/xenomai-kernel-source/ksrc/nucleus/COPYING \
		debian/tmp/usr/src/xenomai-kernel-source/ksrc/skins/native/COPYING \
		debian/tmp/usr/src/xenomai-kernel-source/ksrc/skins/posix/COPYING \
		debian/tmp/usr/src/xenomai-kernel-source/ksrc/skins/psos+/COPYING \
		debian/tmp/usr/src/xenomai-kernel-source/ksrc/skins/rtdm/COPYING \
		debian/tmp/usr/src/xenomai-kernel-source/ksrc/skins/uitron/COPYING \
		debian/tmp/usr/src/xenomai-kernel-source/ksrc/skins/vrtx/COPYING \
		debian/tmp/usr/src/xenomai-kernel-source/ksrc/skins/vxworks/COPYING
	
	dh_auto_install

	
	# remove *.la files
	rm debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.la
	# removing useless-autogenerated-doxygen-file .md5 files of the documentation
	find debian/tmp/usr/share/doc/ -name *.md5 | xargs -n1 rm -rf
	# delete empty directory
	rm -rf debian/tmp/usr/share/doc/xenomai/ps

override_dh_compress:
	dh_compress -X.pdf


override_dh_installmodules:
	# We have some udev files
	dh_installmodules --name=xenomai

override_dh_installudev:
	dh_installudev --name=xenomai

override_dh_installinit:
	dh_installinit --name=xenomai

	
######################################################################
######################################################################
######################################################################
######################################################################

=== debian/watch ===
version=3
opts=\
repacksuffix=+dfsg,\
dversionmangle=s/\+dfsg//,\
 http://download.gna.org/xenomai/stable/xenomai-(.*)\.tar\.bz2
